#include <avr/io.h>

#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>

#include "defines.h"
//#define       F_CPU   8000000
#include <util/delay.h>
#include <avr/eeprom.h>
//#include <avr/pgmspace.h>

//#define globals_main
/*
#define ds1820_port D
#define ds1820_pin  7
#define ds1820_anz_sensor 3
#define eep_ds1820_adr  30
// #ifndef _ds1820_h
//#define _ds1820_h
#define ds1820_verbose 1
*/
#include "ds1820_v3.h"
#include "i2clcd.h"
#include "ir.h"



//================= ds18b20 =============================
//    ____
// ___________
//_____________
// 1   2   3
//GND DAT VCC
//=======================================================
//pinout 0.10



//Tastaturabfrage für Speicherung neuer Sensoren
#define ds1820_tast_port		tast0_port
#define ds1820_tast_pin 		tast0_pin
#define tastds1820		!(pinVAL(tast0_port,tast0_pin))






//#define ds1820_port C
//#define ds1820_pin 5

#define owds1820_clr 		pinCLR(ds1820_port,ds1820_pin)
#define owds1820_output   	pinDIRout(ds1820_port,ds1820_pin)
#define owds1820_set 		pinSET(ds1820_port,ds1820_pin)
#define owds1820_input 		pinDIRin(ds1820_port,ds1820_pin)
#define owds1820_val 		pinVAL(ds1820_port,ds1820_pin)
#define  xcli //cli()
#define  xsei //sei()

// DS1820 commands
#define MATCH_ROM	0x55
#define SKIP_ROM	0xCC
#define	SEARCH_ROM	0xF0
#define CONVERT_T	0x44
#define READ_OW		0xBE
#define WRITE_OW		0x4E
#define EE_WRITE	0x48
#define EE_RECALL	0xB8
#define	SEARCH_FIRST	0xFF		// start new search
#define	PRESENCE_ERR	0xFF
#define	DATA_ERR		0xFE
#define LAST_DEVICE		0x00		// last device found



u8   ds1820_errorlevel[ds1820_anz_sensor];
int16_t 	ds1820_val[ds1820_anz_sensor];
int16_t 	ds1820_tmp[ds1820_anz_sensor];
int16_t 	ds1820_store[ds1820_anz_sensor];
uint16_t    ds1820_id [ds1820_anz_sensor];
uint16_t    ds1820_eep[ds1820_anz_sensor];


int16_t CelsiusTemp;

u8 zl_sensors_eep;
u8 zl_sensors_hw;
u8 zl_sensors_hw_found;
u32 new_sensors_hw32;
u32 eep_sensors_notfound32;
u8 anz_new_sensors;
u8 anz_eep_sensors_notfound;
u8 zl_negative_abfragen;


//------------ hardware --------------------
unsigned char w1_reset(void){
  unsigned char err;
  owds1820_clr;
  owds1820_output;
_delay_us(480);
  xcli;
  owds1820_input;
_delay_us(66);
  err = owds1820_val;			// no presence detect
  xsei;
_delay_us(480-66);
 if( (owds1820_val) == 0 )err = 2;		// short circuit
_delay_ms(1);//kk ge�ndert 30.12.12
return err;
}

unsigned char w1_bit_io( unsigned char b ){
xcli;
owds1820_output;
_delay_us(1);
 if(b) owds1820_input;
_delay_us(14);
 if( (owds1820_val) == 0 )    b = 0;
_delay_us(45);
 owds1820_input;
_delay_ms(1);//kk ge�ndert 30.12.12
  xsei;
  return b;
}

unsigned int w1_byte_wr( unsigned char b ){
  unsigned char i = 8, j;
  do{ j = w1_bit_io( b & 1 );
    b >>= 1;
    if( j )
      b |= 0x80;
  }while( --i );
  return b;
}
unsigned int w1_byte_rd( void ){
  return w1_byte_wr( 0xFF );
}
//------------------------------------------------------

#define idata
unsigned char w1_rom_search( unsigned char diff, unsigned char idata *id )
{
  unsigned char i, j, next_diff;
  char b;

  if( w1_reset() )
    return PRESENCE_ERR;			// error, no device found
  w1_byte_wr( SEARCH_ROM );			// ROM search command
  next_diff = LAST_DEVICE;			// unchanged on last device
  i = 8 * 8;					// 8 bytes
  do{
    j = 8;					// 8 bits
    do{
      b = w1_bit_io( 1 );			// READ_OW bit
      if( w1_bit_io( 1 ) ){			// READ_OW complement bit
	if( b )					// 11
	  return DATA_ERR;			// data error
      }else{
	if( !b ){				// 00 = 2 devices
	  if( diff > i ||
	    ((*id & 1) && diff != i) ){
	    b = 1;				// now 1
	    next_diff = i;			// next pass 0
	  }
	}
      }
      w1_bit_io( b );     			// WRITE_OW bit
      *id >>= 1;
      if( b )					// store bit
	*id |= 0x80;
      i--;
    }while( --j );
    id++;					// next byte
  }while( i );
  return next_diff;				// to continue search
}


void w1_command( unsigned char command, unsigned char idata *id )
{
  unsigned char i;
  w1_reset();
  if( id ){
    w1_byte_wr( MATCH_ROM );			// to a single device
    i = 8;
    do{
      w1_byte_wr( *id );
      id++;
    }while( --i );
  }else{
    w1_byte_wr( SKIP_ROM );			// to all devices
  }
  w1_byte_wr( command );
}


void ds1820_start_meas( void ){
  if( owds1820_val ){
    w1_command( CONVERT_T, NULL );
   owds1820_set;
    owds1820_output;			// parasite power on
  }else{
    //uputsnl( "Short Circuit !" );
  }
}


void ds1820_read_meas( void )
{
uint8_t i;
u8 id[8], diff;
int16_t temp;
zl_sensors_hw=0;

for(i=0;i<ds1820_anz_sensor;i++){
ds1820_errorlevel[i]++;
if(ds1820_errorlevel[i]>3)ds1820_val[i]=851;
}/*
*/



  for( diff = SEARCH_FIRST; diff != LAST_DEVICE; ){
    diff = w1_rom_search( diff, id );

    if( diff == PRESENCE_ERR ){
        //uputsnl( "No Sensor found" );

//void lcd_goto(uint8_t line, uint8_t col );
#if 1//#ifdef lcd_goto
		lcd_goto(2,1);
		lcd_write ( "NSF" );
#endif


	break;
    }

    if( diff == DATA_ERR ){
#if 1//#ifdef lcd_goto
		lcd_goto(2,1);
		lcd_write( "dER" );
#endif
        break;
		}

if( id[0] == 0x28 || id[0] == 0x10 ){	// temperature sensor

	w1_byte_wr( READ_OW );			// READ_OW command
      temp = w1_byte_rd();			// low byte
      temp |= (u8)w1_byte_rd() << 8;		// high byte
      if( id[0] == 0x10 )			// 9 -> 12 bit
        temp <<= 3;


//CelsiusTemp=((temp&0b1111000000000000) | (temp>>4) )*10  + (temp << 12) / 6553 ;
if(gbi(temp,15)){//negativ
CelsiusTemp=((0xf000) | (temp>>4) )*10-(10-((temp & 0x000f)*10+8)/16)+10;
}else{//positiv
CelsiusTemp=( (temp>>4) )*10+
		((temp & 0x000f)*10+8)/16;
}

 ds1820_id[zl_sensors_hw]=(id[2]<<8)+id[7];

 ds1820_tmp[zl_sensors_hw]=CelsiusTemp;
 
 
//  lg(1,1+zl_sensors_hw*5);lcd_hex16 ((id[2]<<8)+id[7]);
  for(i=0;i<zl_sensors_eep;i++) {
//   lg(2+i,1+zl_sensors_hw*5);lcd_hex16 (ds1820_eep[i]);
   if(ds1820_eep[i]==(id[2]<<8)+id[7]){
        ds1820_val[i]=CelsiusTemp;
        ds1820_errorlevel[i]=0;
		
        break;
    }
  }




//++++++ ANZEIGE ID*Messung ++++++++++++
#if ds1820_verbose
		lcd_goto(4,1);
		lcd_hex16 ((id[2]<<8)+id[7]);
		lcd_write(":");
		li4 (CelsiusTemp);
//		lcd_write("x");
//		lcd_int (zl_sensors_hw);
#endif
//------ ANZEIGE ID*Messung ------------


_delay_ms(2);//twi64ok
//li(zl_sensors_hw);
zl_sensors_hw++;
   }//if (id==0x28)
  }//for
// wait;wait;wait;// 
 }



//=================================================

  void eeprom_in_array_einlesen (void){
  u8 zl;
  zl_sensors_eep=0;
    for(zl=0;zl<ds1820_anz_sensor;zl++) {
    ds1820_eep[zl]=eeprom_read_word(eep_ds1820_adr+zl*2);
 //   lg(zl%lcd_max_zl+1,12);lcd_hex16(ds1820_eep[zl]);
        if(ds1820_eep[zl]!=0 && ds1820_eep[zl]!=0xffff ){
            zl_sensors_eep++;
        }else{
            break;}
    }
//  lgi(2,18,zl_sensors_eep);lw("/");li(zl_sensors_hw);
  }

//=================================================
void ds1820_init(void){
			ds1820_start_meas();
			wait;
			ds1820_read_meas();

//  pinDIRin(ds1820_tast_port,ds1820_tast_pin);
//  pinPULLUP(ds1820_tast_port,ds1820_tast_pin,1);
     eeprom_in_array_einlesen();
//     hw_sensors_in_array_einlesen();
	   lgi(2,18,zl_sensors_hw);lw("/");li(zl_sensors_eep);

 //    check_for_new_sensors();
 //    check_eep_sensors();
  }
//===================================
//===================================
//===================================
//===================================
//===================================
//===================================
//===================================
//+++++++++++++++++++++++++++++++++++++++++
	u8 sel_sensor, cur_alt, sel_eep;
	
   void  ds_disp_cursor(u8 sel){
   u8 cur=(sel%(lcd_zeilen-1)+2);
  lcd_goto(cur_alt,1);
   lcd_char(' ');
   lcd_goto(cur,1);
   lcd_char('*');
   
   cur_alt=cur;
   }
	
	
	
	


    void  ds_disp_sens(u8 ct){
	u8 found;
    u8 i,j;
	u8 offset=(ct/(lcd_zeilen-1))*(lcd_zeilen-1);
	u8 start=ct%(lcd_zeilen-1);
	
	
		lcd_goto(1,15);
		lcd_int(ct+1);
		lcd_write("(");
		lcd_int(ds1820_anz_sensor);
		lcd_write(")");
	
	
		for (i=0;i<(lcd_zeilen-1);i+=1){

			lcd_goto(2+i,1);

				if((i+offset+1)>ds1820_anz_sensor){
					lcd_write("        ");
					break;
				}

				lcd_write(" ");
				lcd_int2(i+offset+1);
				lcd_write(".");
				lcd_hex16 (ds1820_id[i+offset]);
				lcd_write(":");
				li4 (ds1820_tmp[i+offset]);
	
			found =0;
			for(j=0;j<ds1820_anz_sensor;j++){
				if(ds1820_eep[j]==ds1820_id[i]){
					lcd_write(" ep");
					lcd_int2(j+1);
					found=1;
				break;
				}
			}				
			if(found==0 && ds1820_id[i]>0){
				lcd_write(" xxxx");
			}	
		}
		
	ds_disp_cursor(ct);	
    }
 
void  eep_show(u8 sel){
	lcd_goto(cur_alt,16);
	lcd_write("Ep");
	lcd_int2(sel+1);
	
	lcd_goto(1,1);
	lcd_write("st/dl ");
	lcd_int(sel_sensor+1);
	lcd_write("at ");
	lcd_int(sel+1);
	lcd_write(":");
	
	lcd_hex16(ds1820_eep[sel]);
}

//---------------------------------- 
  void  sensors_show(void){
 	ds1820_read_meas();
	ds_disp_sens(sel_sensor);
  }




//-----------------------------------------

