#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#define globals_main
#include "defines.h"
#include <util/delay.h>

#include "i2clcd.h"
#include "ir.h"
#include "ds1820_v3.h"

//+++++++++++++++++++ akv ++++++++++++++++++++++
//akv:c3
//comp:b1

//flow sensor b2
#define IR_ADR_FB 72


v u32 timer;
#define led1_port B
#define led1_pin  5


#define akv_on  {sbi(PORTC,3);led1_on;lgw(1,3,"+");}
#define akv_off {cbi(PORTC,3);led1_off;lgw(1,3,"-");}

u8 akv_schaltschwelle=0;
u8 akv_stufe;
v u8 relais=0,relais_alt;
#define relais_wp 			0
#define relais_p1 			1
#define relais_pq 			2
#define relais_ww 			3
#define output_akv 			4
#define akv_init sbi(DDRC,3)
#define comp_init cbi(PORTB,1);sbi(DDRB,1)

#define akv_korrekturwert 28
#define tr_t0 ds1820_val[0]
#define tr_t1 ds1820_val[1]
#define tr_hg ds1820_val[2]
#define tr_wwrl ds1820_val[3]
#define tr_wwvl ds1820_val[4]

void craq_on(void){
sbi(PORTB,1);
lgw(1,13,"wp_1");
akv_schaltschwelle=12;
 lg(1,18);lw("/");lcd_int2(akv_schaltschwelle);//li(akv_schaltschwelle);
//sub_relais(32);
}


void craq_off(void){
cbi(PORTB,1);
akv_schaltschwelle=0;
lgw(1,13,"wp_0");
}




//------------------- akv ----------------------
void main(void){
char time_ct;
int8_t sec;
u8 abfr=0,ir_cmd,ir_adr;
u16 res_ir;
u8 x;
u8 fb_yellow_mnu=0;	
u8 fb_status=0;
#define st_show  1
#define st_store 2

	led1_init;
	i2c_init();
	lcd_init();
	lcd_write("070517_ds1820 ");
	DDRB&=~(1<<2);
	PORTB|=(1<<2);
	
	
	
	akv_init;
	comp_init;
	ds1820_init();
	wait;
	lcd_clear(0);


//ds-Belegung anzeigen:
	lcd_goto(3,1);
	lcd_write("t0 ");
	//li4(ds1820_val[0]);
	lcd_goto(3,5);
	lcd_write("t1 ");
	//li4(ds1820_val[1]);
	lcd_goto(3,9);
	lcd_write("hot");
	//li4(ds1820_val[2]);
	lcd_goto(3,13);
	//li4(ds1820_val[3]);
	lcd_write("wRl");
	lcd_goto(3,17);
	//li4(ds1820_val[3]);
	lcd_write("wVl");





while(1){
	timer++;//PSEUDO-TIMER
//================= ir polling ======================

if(PINB)led1_on;
else
led1_off;


		if(ir_pin){
//		led1_tog;
				res_ir= ir_signal();
				ir_adr=res_ir>>8;
//#if ir_verbose

if(ir_adr!=IR_ADR_FB && ir_adr>0){
				lcd_goto(3,12);lcd_write(" ");
				lcd_int(res_ir>>8);lcd_write("/");
				lcd_int(res_ir&0xff);lcd_write("/");
}
//#endif
				_delay_ms(300);
 
		  if(res_ir>>8==IR_ADR_FB){
				ir_cmd=res_ir&0xff;
				
				if(fb_yellow_mnu){
				if(ir_cmd==fb_yellow){
					lcd_clear(0);//lcd_write("xxxxxxxxxxxxx") ;
					fb_yellow_mnu=0;ir_cmd=0;
				}
				else
				{
				//yellow-commands++++
				  switch (ir_cmd)
				  {
				  /*  case (fb_1_1):
				     lcd_goto(1,1);lcd_write("sensors show") ;
						sensors_show();
				      break;
				
				    case (fb_1_2):
				     lcd_goto(1,1);lcd_write("eeprom show") ;
				      ;
				      break;
				
				    case (fb_1_3):
				     lcd_goto(1,1);lcd_write("sensors store") ;
				      ;
				      break;
				
				    case(fb_1_4):
				     lcd_goto(1,1);lcd_write("sensors delete") ;
				      ;
				      break;
					*/ 
				    case(fb_down):
						if (sel_sensor<ds1820_anz_sensor-1){
							sel_sensor++;
							ds_disp_sens(sel_sensor);
						}
						break;
					  
				    case(fb_up):
						if (sel_sensor>0){
							sel_sensor--;
							ds_disp_sens(sel_sensor);
						}
						break;
					  
				    case(fb_right):
					sbi(fb_status,st_store);
						if (sel_eep<ds1820_anz_sensor-1){
						
							sel_eep++;
							eep_show(sel_eep);
							//ds_disp_sens(sel_sensor);
						}
						break;
					  
				    case(fb_left):
					sbi(fb_status,st_store);
						if (sel_eep>0){
							sel_eep--;
							eep_show(sel_eep);
							
							
						}
						break;
					
				    case(fb_green):
						if(gbi(fb_status,st_store)){
							x=eep_ds1820_adr+sel_eep*2;
							eeprom_update_word(x,ds1820_id[sel_sensor]);
							     eeprom_in_array_einlesen();

							
							lcd_goto(cur_alt,16);
							lcd_hex16(ds1820_id[sel_sensor]);
							lcd_goto(1,16);
							lcd_int(x);
						}
						break;
					
				    case(fb_red):
						if(gbi(fb_status,st_store)){
							x=eep_ds1820_adr+sel_eep*2;
							eeprom_update_word(x,0xffff);
							     eeprom_in_array_einlesen();

							
							lcd_goto(cur_alt,16);
							lcd_hex16(0xffff);
							lcd_goto(1,16);
							lcd_int(x);
						}
						break;
				      
				  }
				
				
				
				
				//yellow-commands----
				}
				}
				
				
				if(!fb_yellow_mnu){
				  switch (ir_cmd)
				  {
				    case (fb_yellow):
				     lcd_goto(1,1);lcd_write("sensors show...") ;
						ds1820_start_meas();
						wait;
						//lcd_goto(1,1);lcd_write("yellow menu") ;
						fb_yellow_mnu=1;
						sensors_show();
				      break;
				
				    case (fb_2_4):
				      if(gbi(PORTB,1)){
						craq_off();
					  }else{
						craq_on();
					  }
				      break;
					 
					 case (fb_vol_minus):
					 if(akv_schaltschwelle>0)akv_schaltschwelle--;
					 lcd_goto(1,19);lcd_int2(akv_schaltschwelle);
					 break;
					 
					 case (fb_vol_plus):
					 if(akv_schaltschwelle<15)akv_schaltschwelle++;
					 lcd_goto(1,19);lcd_int2(akv_schaltschwelle);
					 break;
 				  }
				}
				
				res_ir=0;
//				lcd_light(1);
		/*  */}
		   }//ir_pin	
//================= ir polling ======================

	
	
	
	
	
//=====================================	
	if (timer==187295){
		timer=0;
sec++;
if (sec==60)sec=0;
		time_ct++;
//====================================


//16stufige Schaltung Danfoss AKV
    akv_stufe++;
        if(akv_stufe>15){
            akv_stufe=0;
            if(akv_schaltschwelle>0)akv_on;
        }
        if(akv_stufe==akv_schaltschwelle)akv_off;






//====================================		
		
if(!fb_yellow_mnu){		
		lcd_goto(1,1);
		
		lcd_int2(sec);

if (sec%20==10){
ds1820_start_meas();

}
if (sec%20==0){
	ds1820_read_meas();
	lcd_goto(3,1);
	li4(ds1820_val[0]);
	//lcd_goto(3,6);
	li4(ds1820_val[1]);
	//lcd_goto(3,11);
	li4(ds1820_val[2]);
	//lcd_goto(3,16);
	li4(ds1820_val[3]);
	li4(ds1820_val[4]);

}




}//if(!fb_yellow_mnu)
}//sec
}//while

;
}


//----------------------------------
